/*
   Help functions
   --------------------------------------------------------------------
   Linberto

   Copyright (C) 1999-2001 Diego Javier Grigna <diego@grigna.com>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "common.h"

static void help_show_page_zero(  void);
static void help_show_page_one(   void);
static int  help_show_page_two(   void);
static int  help_show_page_three( void);
static int  help_show_page_four(  void);
static void help_show_page_five(  void);
static void help_show_page_six(   void);
static void help_show_page_seven( void);

void help_show_instructions( void)
{
 int pos = 0;

 game_init_actors();

 stage     = DEFAULT_STAGE; 
 level     = -1;
 game_init_map_stage( LINBERTO_WORLDFILE);
 level     = 0;

 help_show_page_zero();

 while( 1) {
        if( keyboard_update() == 0 && joy_moved() == 0)
            continue;

        switch( lin_scancode) {
           case SCANCODE_Q:
           case SCANCODE_ESCAPE:
                  return;
           case SCANCODE_ENTER:
           case SCANCODE_KEYPADENTER:
                  pos++;
                  if( pos >  7) return;
                  if( pos == 1) help_show_page_one();
                  if( pos == 2) if( help_show_page_two()   == 0) return;
                  if( pos == 3) if( help_show_page_three() == 0) return;
                  if( pos == 4) if( help_show_page_four()  == 0) return;
                  if( pos == 5) help_show_page_five();
                  if( pos == 6) help_show_page_six();
                  if( pos == 7) help_show_page_seven();
        } /* end switch */
 } /* end while( 1) */

}

static void help_show_page_zero( void)
{
 char buffer[ 128];
 gl_clearscreen( 0);

 draw_block( 150, 30, lcolors[ 1]);

 sprite_linberto.x = LIN_START_X;
 sprite_linberto.y = LIN_START_Y;
 sprite_put_mask( &sprite_linberto);

 sprintf( buffer, _("Version %s"), LINBERTO_VERSION);

 screen_center_text( _("Linberto")                  ,  70);
 screen_center_text( buffer                         ,  90);
 screen_center_text( _("Copyright (C) 1999-2001"  ) , 110);
 screen_center_text( _("Diego Javier Grigna"      ) , 120);
 screen_center_text( _("email: <diego@grigna.com>") , 140);
 screen_center_text( _("Web page:"                ) , 160);
 screen_center_text( _("http://www.grigna.com/diego/linux/"), 170);

 press_enter_str();
}

static void help_show_page_one( void)
{
 int l1, l2, l3, l4, i;

 gl_clearscreen( 0);

 screen_center_text( _("Game Characters:"), 0);

 draw_block( 283, 40, lcolors[ 1]);
 sprite_linberto.x = 274;
 sprite_linberto.y = 23;
 sprite_put_mask( &sprite_linberto);

 gl_write( 0, 28, _("Linberto "));
 gl_write( 0, 48, _("The cube "));

 sprite_bubble.x = 272;
 sprite_bubble.y = 105;
 sprite_put_mask( &sprite_bubble);
 gl_write( 0, 112, _("The evil bubble "));

 sprite_flowerpot.x = 265;
 sprite_flowerpot.y = 135;
 sprite_put_mask( &sprite_flowerpot);
 gl_write( 0, 162, _("The evil flower pot "));

 l1 = strlen( _("Linberto "));
 l2 = strlen( _("The cube "));
 l3 = strlen( _("The evil bubble "));
 l4 = strlen( _("The evil flower pot "));

 for( i = 0; i < 32 - MIN( MIN( l1, l2), MIN( l3, l4)); i++) {
      if( i < 32 - l1)
          gl_write( l1 * 8 + 8 * i,  28, "\376\032");
      if( i < 32 - l2)
          gl_write( l2 * 8 + 8 * i,  48, "\376\032");
      if( i < 32 - l3)
          gl_write( l3 * 8 + 8 * i, 112, "\376\032");
      if( i < 32 - l4)
          gl_write( l4 * 8 + 8 * i, 162, "\376\032");
      if( misc_wait( 8, WAIT_ESC_ESC) == 0)
          break;
 }
 
 press_enter_str();
}

static int help_show_page_two( void)
{
 gl_clearscreen( 0);

 game_init_actors();

 draw_block( 150, 30, lcolors[ 1]);
 draw_block( 134, 51, lcolors[ 1]);
 gl_copyscreen( backscreen);

 move_sprite();

 screen_center_text( _("To pass each level, you need to jump  "), 100);
 screen_center_text( _("from block to block until all the cu- "), 110);
 screen_center_text( _("bes gets white.                       "), 120);
 screen_center_text( _("If you jump beyond the edge of the cu-"), 140);
 screen_center_text( _("bes or if an evil character lands in  "), 150);
 screen_center_text( _("your position, you lose a life.       "), 160);
 screen_center_text( _("\375                                     "), 170);

 if( misc_wait( 100, WAIT_ESC_ESC) == 0)
     return 0;
 move_sprite_downleft();
 game_draw_block();

 if( misc_wait( 100, WAIT_ESC_ESC) == 0)
     return 0;
 move_sprite_upright();
 game_draw_block();

 press_enter_str();
 return 1;
}

static int help_show_page_three( void)
{
 gl_clearscreen( 0);

 game_init_actors();

 draw_block( 150, 30, lcolors[ 1]);
 draw_block( 134, 51, lcolors[ 1]);
 gl_copyscreen( backscreen);

 move_sprite();

 screen_center_text( _("To jump down left, use the LEFT ARROW "), 100);
 screen_center_text( _("key or the key 1 in numeric keypad.   "), 110);
 screen_center_text( _(" \375                                    "), 120);

 if( misc_wait( 100, WAIT_ESC_ESC) == 0)
     return 0;
 move_sprite_downleft();
 game_draw_block();

 screen_center_text( _("To jump up right, use the RIGHT ARROW "), 140);
 screen_center_text( _("key or the key 9 in numeric keypad.   "), 150);
 screen_center_text( _("  \375                                   "), 160);

 if( misc_wait( 100, WAIT_ESC_ESC) == 0)
     return 0;
 move_sprite_upright();
 game_draw_block();

 press_enter_str();
 return 1;
}

static int help_show_page_four( void)
{
 gl_clearscreen( 0);

 game_init_actors();

 draw_block( 150, 30, lcolors[ 1]);
 draw_block( 166, 51, lcolors[ 1]);
 gl_copyscreen( backscreen);

 move_sprite();

 screen_center_text( _("To jump down right, use the DOWN ARROW"), 100);
 screen_center_text( _("key or the key 3 in numeric keypad.   "), 110);
 screen_center_text( _("   \375                                  "), 120);

 if( misc_wait( 100, WAIT_ESC_ESC) == 0)
     return 0;
 move_sprite_downright();
 game_draw_block();

 screen_center_text( _("To jump up right, use the UP ARROW    "), 140);
 screen_center_text( _("key or the key 7 in numeric keypad.   "), 150);
 screen_center_text( _("    \375                                 "), 160);

 if( misc_wait( 100, WAIT_ESC_ESC) == 0)
     return 0;
 move_sprite_upleft();
 game_draw_block();

 press_enter_str();
 return 1;
}

static void help_show_page_five( void)
{
 gl_clearscreen( 0);

 screen_center_text( _("Miscellaneous keys")                     ,   0);
 screen_center_text( _(" SPACE or 'P' : Pause the game.       ") ,  30);
 screen_center_text( _(" 'I'          : Toggle viewing of the ") ,  60);
 screen_center_text( _("                game score, level and ") ,  70);
 screen_center_text( _("                lives banners.        ") ,  80);
 screen_center_text( _(" 'S'          : Turn sound ON/OFF     ") , 110);
 screen_center_text( _(" ESC or 'Q'   : Quits the game.       ") , 140);

 press_enter_str();
}

static void help_show_page_six( void)
{
 gl_clearscreen( 0);

 screen_center_text( _("More keys:")                    ,   0);
 screen_center_text( _(" F1 : Takes a screen shot.   ") ,  40);
 screen_center_text( _(" F10: Set normal brightness. ") ,  60);
 screen_center_text( _(" F11: Increase brightness.   ") ,  80);
 screen_center_text( _(" F12: Decrease brightness.   ") , 100);

 press_enter_str();
}

static void help_show_page_seven( void)
{
 gl_clearscreen( 0);

 screen_center_text( _("Additional comments:")               ,  0);
 screen_center_text( _("When in INVINCIBLE MODE, your score"), 50);
 screen_center_text( _("won't be saved and the evils won't "), 60);
 screen_center_text( _("appear.                            "), 70);

 press_enter_str();
}


